package com.blogspot.lucbors.view.beans;

import javax.faces.component.UIComponent;
import javax.faces.event.ActionEvent;

import oracle.adf.model.BindingContext;
import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.binding.DCIteratorBinding;
import oracle.adf.view.rich.component.rich.data.RichTable;

import oracle.adf.view.rich.context.AdfFacesContext;

import oracle.adf.view.rich.event.PopupFetchEvent;

import oracle.binding.BindingContainer;

import oracle.jbo.ApplicationModule;
import oracle.jbo.Key;
import oracle.jbo.Row;
import oracle.jbo.uicli.binding.JUCtrlHierBinding;

import oracle.jbo.uicli.binding.JUCtrlHierNodeBinding;

import org.apache.myfaces.trinidad.event.SelectionEvent;
import org.apache.myfaces.trinidad.model.CollectionModel;

public class TwoTablesBean {

  DCIteratorBinding theCurrentOne;
  
  boolean readOnly = true;

  public TwoTablesBean() {
  }

  public void makeSelectionAndSetActiveTable(SelectionEvent selectionEvent) {
    // Add event code here...


    RichTable _table = (RichTable)selectionEvent.getSource();
    //the Collection Model is the object that provides the structured data
    //for the table to render
    CollectionModel _tableModel = (CollectionModel)_table.getValue();
    //the ADF object that implements the CollectionModel is JUCtrlHierBinding. It
    //is wrapped by the CollectionModel API
    JUCtrlHierBinding _adfTableBinding =
      (JUCtrlHierBinding)_tableModel.getWrappedData();
    //Acess the ADF iterator binding that is used with ADF table binding
    DCIteratorBinding _tableIteratorBinding =
      _adfTableBinding.getDCIteratorBinding();

    Object _selectedRowData = _table.getSelectedRowData();
    //cast to JUCtrlHierNodeBinding, which is the ADF object that represents
    //a row
    JUCtrlHierNodeBinding _nodeBinding =
      (JUCtrlHierNodeBinding)_selectedRowData;
    //get the row key from the node binding and set it as the current row in the
    //iterator
    Key _rwKey = _nodeBinding.getRowKey();
    _tableIteratorBinding.setCurrentRowWithKey(_rwKey.toStringFormat(true));

    setTheCurrentOne(_tableIteratorBinding);
  }

  public void setTheCurrentOne(DCIteratorBinding theCurrentOne) {
    this.theCurrentOne = theCurrentOne;
  }

  public DCIteratorBinding getTheCurrentOne() {
    if (theCurrentOne==null){      
      DCBindingContainer dcBindings = (DCBindingContainer)getBindings();
      return  dcBindings.findIteratorBinding("DepIt");
    }
    return theCurrentOne;
  }


  public void createRecord(ActionEvent evt) {
    DCIteratorBinding it = getTheCurrentOne();
    Row rw = it.getNavigatableRowIterator().createRow();
    rw.setNewRowState(Row.STATUS_INITIALIZED);
    it.getNavigatableRowIterator().insertRow(rw);
    
  
    refreshUpdatedTable(evt);

   
  }


  public void editRecord(ActionEvent evt) {
    //

  }

  public void deleteRecord(ActionEvent evt) {
    
    //
  }

  public void saveChanges(ActionEvent evt) {
    //
    DCIteratorBinding it = getTheCurrentOne();
    ApplicationModule am = null;
    am = it.getDataControl().getApplicationModule();
    am.getTransaction().commit();
  
    
    refreshUpdatedTable(evt);
  }

  public void undoChanges(ActionEvent evt) {
    //
    DCIteratorBinding it = getTheCurrentOne();
    ApplicationModule am = null;
    am = it.getDataControl().getApplicationModule();
    am.getTransaction().rollback();
 
 
    
    refreshUpdatedTable(evt);

  }


  private void refreshUpdatedTable(ActionEvent evt) {

    UIComponent component = evt.getComponent();

    AdfFacesContext adfFacesContext = AdfFacesContext.getCurrentInstance();
    adfFacesContext.addPartialTarget(component);
  }

  public void popupFetchListener(PopupFetchEvent popupFetchEvent) {


  }

  public void setReadOnly(boolean readOnly) {
    this.readOnly = readOnly;
  }

  public boolean isReadOnly() {
    return readOnly;
  }
  
  public BindingContainer getBindings(){
    return BindingContext.getCurrent().getCurrentBindingsEntry();
  }
}

